<?php

// PHP標準のflock方式のファイルロック

function _lock(){
	$fp = fopen("./lockdir/lockfile", 'a+');
	$locked = $fp && flock($fp, LOCK_EX);
	if(! $locked) {
		die('lock busy');
	}
	return $fp;
}



function _unlock($fp){
	fclose($fp);
}



function my_scandir($dir) {
	$dh  = opendir($dir);
	$files = array();
	while (false !== ($filename = readdir($dh))) {
		$files[] = $filename;
	}
	return $files;
}


function test_func(){

	//ロックする(タイムアウトあり)
	$lfh = _lock();
	
		// read
		$filename = './data/output1.txt';
		$rfp = fopen($filename,'r') or die("ファイル({$filename})のオープンに失敗しました");
		$line = fgets($rfp,1024);
		if (! $line){ $line=0;}
		$line++;
		fclose($rfp);
		
		print $line.'<br>';
		
		// write
		umask(0000);
		$tmp_filename = './data/'.getmypid().'.tmp';
		$fp = fopen($tmp_filename, 'w');
		fwrite($fp, $line);
		fclose( $fp );
		rename($tmp_filename, $filename);
		
	
	//アンロックする
	_lock($lfh);

	// 0.1秒sleep
	usleep(100000);

}

// テストを100回実行
for ($i=0;$i<100;$i++){
	test_func();
}



?>
